Loading...
Searching...
No Matches
juce::StringPool Class Reference

## Detailed Description

A StringPool holds a set of shared strings, which reduces storage overheads and improves comparison speed when dealing with many duplicate strings.

When you add a string to a pool using getPooledString, it'll return a character array containing the same string. This array is owned by the pool, and the same array is returned every time a matching string is asked for. This means that it's trivial to compare two pooled strings for equality, as you can simply compare their pointers. It also cuts down on storage if you're using many copies of the same string.

The documentation for this class was generated from the following file:

- juce_core/text/juce_StringPool.h

## Public Member Functions

| StringPool () noexcept
| Creates an empty pool.
String | getPooledString (const String &original)
| Returns a pointer to a shared copy of the string that is passed in.
String | getPooledString (const char *original)
| Returns a pointer to a copy of the string that is passed in.
String | getPooledString (StringRef original)
| Returns a pointer to a shared copy of the string that is passed in.
String | getPooledString (String::CharPointerType start, String::CharPointerType end)
| Returns a pointer to a copy of the string that is passed in.
void | garbageCollect ()
| Scans the pool, and removes any strings that are unreferenced.

## Static Public Member Functions

static StringPool & | getGlobalPool () noexcept
| Returns a shared global pool which is used for things like Identifiers, XML parsing.

## Constructors and Destructors

## StringPool()

juce::StringPool::StringPool | ( |  | ) |

noexcept

Creates an empty pool.

Referenced by getGlobalPool().

## Member Functions

## getPooledString() [1/4]

String juce::StringPool::getPooledString | ( | const String & | original | ) |

Returns a pointer to a shared copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

References getPooledString().

Referenced by getPooledString(), getPooledString(), getPooledString(), and getPooledString().

## getPooledString() [2/4]

String juce::StringPool::getPooledString | ( | const char * | original | ) |

Returns a pointer to a copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

References getPooledString().

## getPooledString() [3/4]

String juce::StringPool::getPooledString | ( | StringRef | original | ) |

Returns a pointer to a shared copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

References getPooledString().

## getPooledString() [4/4]

String juce::StringPool::getPooledString | ( | String::CharPointerType | start,
|  | String::CharPointerType | end )

Returns a pointer to a copy of the string that is passed in.

The pool will always return the same String object when asked for a string that matches it.

References juce::end(), and getPooledString().

## garbageCollect()

void juce::StringPool::garbageCollect | ( |  | ) |

Scans the pool, and removes any strings that are unreferenced.

You don't generally need to call this - it'll be called automatically when the pool grows large enough to warrant it.

References garbageCollect().

Referenced by garbageCollect().

## getGlobalPool()

StringPool & juce::StringPool::getGlobalPool | ( |  | ) |

static noexcept

Returns a shared global pool which is used for things like Identifiers, XML parsing.

References getGlobalPool(), JUCE_DECLARE_NON_COPYABLE, and StringPool().

Referenced by getGlobalPool().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited